"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.unflatten = void 0;

var _isNaN = _interopRequireDefault(require("lodash/isNaN"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var flatten = function flatten(obj) {
  var flattened = {};

  function recurse(current, property) {
    if (!property && Object.getOwnPropertyNames(current).length === 0) {
      return;
    }

    if (Object(current) !== current || Array.isArray(current)) {
      flattened[property] = current;
    } else {
      var isEmpty = true;

      for (var p in current) {
        isEmpty = false;
        recurse(current[p], property ? property + '.' + p : p);
      }

      if (isEmpty) {
        flattened[property] = {};
      }
    }
  }

  if (obj) {
    recurse(obj);
  }

  return flattened;
};

var unflatten = function unflatten() {
  var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var result = {};

  var _loop = function _loop(i) {
    var keys = i.split('.');
    keys.reduce(function (r, e, j) {
      return r[e] || (r[e] = (0, _isNaN["default"])(Number(keys[j + 1])) ? keys.length - 1 === j ? data[i] : {} : []);
    }, result);
  };

  for (var i in data) {
    _loop(i);
  }

  return result;
};

exports.unflatten = unflatten;
var _default = flatten;
exports["default"] = _default;