"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.install = install;
Object.defineProperty(exports, "Validator", {
  enumerable: true,
  get: function get() {
    return _validatorjs["default"];
  }
});
exports["default"] = void 0;

var _isUndefined = _interopRequireDefault(require("lodash/isUndefined"));

var _isFunction = _interopRequireDefault(require("lodash/isFunction"));

var _get = _interopRequireDefault(require("lodash/get"));

var _merge2 = _interopRequireDefault(require("lodash/merge"));

var _flatten = _interopRequireDefault(require("./flatten"));

var _validatorjs = _interopRequireDefault(require("@chantouchsek/validatorjs"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function install(Vue) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

  var defaults = _objectSpread({
    locale: 'en',
    input: {},
    rules: {},
    customMessages: {},
    customAttributes: {},
    watch: false,
    immediate: true,
    langDir: 'lang'
  }, options);

  Vue.mixin({
    beforeCreate: function beforeCreate() {
      this.$options.$vlidator = {};
      var input = this.$data || {};
      Object.assign(defaults, {
        input: input,
        rules: {}
      });
      Vue.util.defineReactive(this.$options, '$vlidator', new _validatorjs["default"](defaults));

      if (!this.$options.computed) {
        this.$options.computed = {};
      }

      this.$options.computed.$vlidator = function () {
        return this.$options.$vlidator;
      };
    },
    created: function created() {
      var this_ = this;
      var _defaults$watch = defaults.watch,
          watch = _defaults$watch === void 0 ? false : _defaults$watch,
          _defaults$immediate = defaults.immediate,
          immediate = _defaults$immediate === void 0 ? false : _defaults$immediate;
      var vlidator = this_.$options.vlidator;

      if (vlidator && vlidator.rules) {
        var _vlidator$rules = vlidator.rules,
            rules = _vlidator$rules === void 0 ? {} : _vlidator$rules;
        Object.entries((0, _flatten["default"])(this_.$data)).forEach(function (_ref) {
          var _ref2 = _slicedToArray(_ref, 2),
              path = _ref2[0],
              _ = _ref2[1];

          var validations = (0, _get["default"])(rules, path);

          if (validations !== undefined && watch) {
            this_.$watch(path, function (value) {
              this_.validate({
                value: value
              });
            }, {
              deep: true,
              immediate: immediate
            });
          }
        });
      }
    },
    methods: {
      validate: function validate() {
        var _arguments = arguments,
            _this = this;

        return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
          var payload, this_, _merge, _merge$langDir, langDir, locale, vlidator, vMessage, vAttributes, _vlidator$rules2, rules, input, _yield$_this$loadLang, _yield$_this$loadLang2, attributes, _yield$_this$loadLang3, messages, options, validator, errors;

          return regeneratorRuntime.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  payload = _arguments.length > 0 && _arguments[0] !== undefined ? _arguments[0] : {};
                  this_ = _this;
                  _merge = (0, _merge2["default"])(defaults, payload), _merge$langDir = _merge.langDir, langDir = _merge$langDir === void 0 ? 'lang' : _merge$langDir;
                  locale = this_.$options.$vlidator.getDefaultLang();

                  if (this_.$i18n) {
                    locale = this_.$i18n.locale;
                  }

                  vlidator = this_.$options.vlidator;
                  vMessage = vlidator.messages, vAttributes = vlidator.attributes, _vlidator$rules2 = vlidator.rules, rules = _vlidator$rules2 === void 0 ? {} : _vlidator$rules2;
                  input = getData({
                    rules: rules,
                    data: this_.$data
                  });
                  _context.next = 10;
                  return _this.loadLanguageAsync(langDir, locale);

                case 10:
                  _yield$_this$loadLang = _context.sent;
                  _yield$_this$loadLang2 = _yield$_this$loadLang.attributes;
                  attributes = _yield$_this$loadLang2 === void 0 ? {} : _yield$_this$loadLang2;
                  _yield$_this$loadLang3 = _yield$_this$loadLang.messages;
                  messages = _yield$_this$loadLang3 === void 0 ? {} : _yield$_this$loadLang3;
                  Object.assign(defaults, _objectSpread(_objectSpread({
                    locale: locale
                  }, vlidator), {}, {
                    input: input,
                    customAttributes: attributes,
                    customMessages: messages
                  }));
                  options = {
                    locale: locale,
                    rules: rules,
                    input: input,
                    confirmedReverse: false,
                    customMessages: _objectSpread(_objectSpread({}, messages), vMessage),
                    customAttributes: _objectSpread(_objectSpread({}, attributes), vAttributes)
                  };
                  validator = new _validatorjs["default"](options);

                  if (!validator.passes()) {
                    _context.next = 20;
                    break;
                  }

                  return _context.abrupt("return", true);

                case 20:
                  this_.$options.$vlidator = validator;

                  if (!(0, _isUndefined["default"])(this_.$errors) && (0, _isFunction["default"])(this_.$errors.fill)) {
                    errors = validator.errors.all() || {};
                    this_.$errors.fill(errors);
                  }

                  return _context.abrupt("return", false);

                case 23:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee);
        }))();
      },
      loadLanguageAsync: function loadLanguageAsync(langDir, locale) {
        try {
          var langFileModule = require('~/lang/' + locale);

          var _ref3 = langFileModule["default"] || langFileModule,
              _ref3$attributes = _ref3.attributes,
              attributes = _ref3$attributes === void 0 ? {} : _ref3$attributes,
              _ref3$messages = _ref3.messages,
              messages = _ref3$messages === void 0 ? {} : _ref3$messages;

          return {
            attributes: attributes,
            messages: messages
          };
        } catch (error) {
          // eslint-disable-next-line no-console
          console.error(error);
        }
      }
    }
  });
}
/**
 * Get Data
 * @param {Object} payload
 * @returns {Object}
 */


var getData = function getData() {
  var payload = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var input = {};
  var _payload$rules = payload.rules,
      rules = _payload$rules === void 0 ? {} : _payload$rules,
      _payload$data = payload.data,
      data = _payload$data === void 0 ? {} : _payload$data;

  for (var item in rules) {
    if (data.hasOwnProperty(item)) {
      Object.assign(input, _defineProperty({}, item, data[item]));
    }
  }

  return input;
};

var _default = {
  install: install
};
exports["default"] = _default;